package top.liangwy.read_statistics.controller;

import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.session.SqlSession;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import top.liangwy.read_statistics.common.BaseController;
import top.liangwy.read_statistics.dao.DeptMapper;
import top.liangwy.read_statistics.dao.UserMapper;
import top.liangwy.read_statistics.dao.WbMapper;
import top.liangwy.read_statistics.pojo.Dept;
import top.liangwy.read_statistics.pojo.User;
import top.liangwy.read_statistics.pojo.Result.UserScan;
import top.liangwy.read_statistics.utils.MybatisUtils;

import java.time.LocalDateTime;
import java.util.*;

/**
 * @author lwy
 * @ 微博
 */
@Controller
@Slf4j
@RequestMapping("/wb")
public class WbController extends BaseController {

//    private static final Logger logger = LoggerFactory.getLogger(WbController.class);

    @GetMapping("/today")
    public String today(Model model) {

        int status = 0;

        SqlSession sqlSession = MybatisUtils.getSqlSession();
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);
        DeptMapper deptMapper = sqlSession.getMapper((DeptMapper.class));
        WbMapper wbMapper = sqlSession.getMapper(WbMapper.class);

        LocalDateTime now = LocalDateTime.now();
        int year = now.getYear();
        int month = now.getMonthValue();
        int day = now.getDayOfMonth();
        String wbUserScanString = wbMapper.getWbUserScanList();
        if (null == wbUserScanString) {
            status = 1;
        } else {
            log.info("微博点赞评论人员是：" + wbUserScanString);
            String newWbUserScanString = wbFree + wbUserScanString.replace(" ", "");
            log.info(newWbUserScanString);
            String[] a = newWbUserScanString.split(",");
            model.addAttribute("date", year + "年" + month + "月" + day + "日");

            // 获取所有部门名称
            List<Dept> deptList = deptMapper.getAllDeptName();

            // 创建有序键值对储存总的数据
            Map<String, List<UserScan>> map = new LinkedHashMap<>(deptList.size());

            for (int i = 1; i < deptList.size(); i++) {

                // 获取指定部门的人员信息
                List<User> arrayList = userMapper.getUserByDeptId(deptList.get(i).getDeptId());
                List<UserScan> userList = new ArrayList<>();
                for (User user : arrayList) {
                    UserScan us = new UserScan();
                    us.setUserName(user.getUserName());
                    us.setNickName(user.getWbNickName());
                    for (String s : a) {
                        if (null == us.getNickName()) {
                            us.setNickName("");
                        }
                        if (us.getNickName().equals(s)) {
                            us.setScanStatus("已完成");
                        }
                    }
                    userList.add(us);
                }
                map.put(deptList.get(i).getDeptName(), userList);
            }
            model.addAttribute("list", map);
        }
        sqlSession.close();
        model.addAttribute("status", status);
        return "/wb/today";
    }

    @RequestMapping("/insert")
    public String edit(String wbUserScanList, Model model) {

        if (wbUserScanList == null) {
            //正常get访问，不用处理，直接返回insert页
            return "/wb/insert";
        }

        SqlSession sqlSession = MybatisUtils.getSqlSession();
        WbMapper wbMapper = sqlSession.getMapper(WbMapper.class);

        //因为微博复制出来的有两个空行，去掉后再存入数据库
        log.info("前端页面传入的wbUserScanList: " + wbUserScanList);
        String str = wbUserScanList.replace("\r\n\r\n", ",");
        String newWbUserScanList = wbFree + str;
        log.info("准备要输入数据库中的newWbUserScanList: " + newWbUserScanList);
        int i = wbMapper.setWbUserScanList(newWbUserScanList);
        if (i == 1) {
            //插入成功
            sqlSession.commit();
            sqlSession.close();
            model.addAttribute("info", "success");
        }
        sqlSession.close();
        return "/wb/insert";
    }
}
